Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadToolTipControllerClass=function(){
this._tooltipToShow=null;
this._activeToolTip=null;
this._registerGlobalBodyEventHandlers();
};
Telerik.Web.UI.RadToolTipControllerClass.prototype={_registerGlobalBodyEventHandlers:function(){
var _1=Function.createDelegate(this,function(e){
if(e.keyCode==27){
if(this._activeToolTip&&!this._activeToolTip.isModal()){
this._hideCurrentToolTipNoAnimation();
}
}
});
$addHandler(document.body,"keydown",_1);
var _3=Function.createDelegate(this,function(e){
this._hideOnBodyClick(e);
});
$addHandler(document.body,"click",_3);
Sys.Application.add_unload(function(){
$removeHandler(document.body,"keydown",_1);
$removeHandler(document.body,"click",_3);
});
},_hideOnBodyClick:function(e){
var _6=false;
if(this._activeToolTip!=null&&!this._activeToolTip.isModal()){
var _7=this._activeToolTip;
if(_7._isMouseOverElement(e,_7._tableElement)){
return;
}
_6=this._activeToolTip._hideIfNotManualCloseOrFromCode();
}
if(_6){
this._activeToolTip=null;
}
},_cancelLastShowRequest:function(){
if(this._tooltipToShow){
var _8=this._tooltipToShow;
this._tooltipToShow=null;
_8.cancelShowDelay();
}
},_hideCurrentToolTipNoAnimation:function(){
this._cancelLastShowRequest();
if(this._activeToolTip!=null){
this._activeToolTip._hideNoAnimation();
}
this._activeToolTip=null;
},requestShow:function(_9){
this._cancelLastShowRequest();
var _a=this._activeToolTip;
if(_a==_9){
return;
}else{
if(_a){
_a._hideIfNotManualCloseOrFromCode();
}
}
this._tooltipToShow=_9;
},cancelSpecificShowRequest:function(_b){
if(this._tooltipToShow==_b){
this._cancelLastShowRequest();
}
},showTooltip:function(_c){
if(!_c||_c.isVisible()){
return;
}
this._cancelLastShowRequest();
this.set_activeToolTip(_c);
_c.show();
},notifyToolTipClosed:function(_d){
if(this._activeToolTip==_d){
this._activeToolTip=null;
}
},set_activeToolTip:function(_e){
if(_e!=this._activeToolTip){
this._hideCurrentToolTipNoAnimation();
}
this._activeToolTip=_e;
},get_activeToolTip:function(){
return this._activeToolTip;
},getInstance:function(){
return this;
}};
Telerik.Web.UI.RadToolTipControllerClass.registerClass("Telerik.Web.UI.RadToolTipControllerClass",null);
if(!Telerik.Web.UI.RadToolTipController){
Telerik.Web.UI.RadToolTipController=new Telerik.Web.UI.RadToolTipControllerClass();
}
Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadToolTip=function(_f){
Telerik.Web.UI.RadToolTip.initializeBase(this,[_f]);
this._offsetX=0;
this._offsetY=6;
this._position=Telerik.Web.UI.ToolTipPosition.BottomCenter;
this._horizontalPosition=null;
this._verticalPosition=null;
this._targetControlID=null;
this._serverTargetControlID=null;
this._serverValue="";
this._formID=null;
this._targetControl=null;
this._popupElement=null;
this._tableElement=null;
this._contentCell=null;
this._titleElement=null;
this._contentElement=null;
this._calloutElement=null;
this._closeLink=null;
this._popupBehavior=null;
this._popupVisible=false;
this._modal=false;
this._onModalShowHandler=null;
this._onModalCloseHandler=null;
this._skin="Default";
this._title="";
this._text="";
this._width="";
this._height="";
this._relativeTo=Telerik.Web.UI.ToolTipRelativeDisplay.Mouse;
this._contentScrolling=Telerik.Web.UI.ToolTipScrolling.Default;
this._showEvent=Telerik.Web.UI.ToolTipShowEvent.OnMouseOver;
this._hideEvent=Telerik.Web.UI.ToolTipHideEvent.Default;
this._visibleOnPageLoad=false;
this._sticky=false;
this._manualClose=false;
this._mouseTrailing=false;
this._showCallout=true;
this._showDelayRef=null;
this._autoCloseRef=null;
this._showDelay=400;
this._autoCloseDelay=3000;
this._hideDelay=300;
this._animation=Telerik.Web.UI.ToolTipAnimation.None;
this._tooltipAnimation=null;
this._zIndex=8000;
};
Telerik.Web.UI.RadToolTip.getCurrent=function(){
var _10=Telerik.Web.UI.RadToolTipController.getInstance();
if(!_10){
return null;
}
return _10.get_activeToolTip();
};
Telerik.Web.UI.RadToolTip.prototype={get_zIndex:function(){
return this._zIndex;
},set_zIndex:function(_11){
var _12=parseInt(_11);
if(isNaN(_11)){
return;
}
if(this._zIndex!=_11){
this._zIndex=_11;
}
},initialize:function(){
Telerik.Web.UI.RadToolTip.callBaseMethod(this,"initialize");
this.set_position(this._position);
var _13=this.get_text();
if(this._targetControl&&!_13){
_13=this._targetControl.getAttribute("title");
if(_13){
this._targetControl.removeAttribute("title");
}
this._text=_13;
}
var _14=$telerik.getCurrentStyle(this.get_element(),"zIndex");
if(null!=_14){
this.set_zIndex(_14);
}
if(this._visibleOnPageLoad){
setTimeout(Function.createDelegate(this,function(){
this.show();
}),0);
}
},dispose:function(){
if(this._tooltipAnimation){
this._tooltipAnimation.dispose();
}
if(this._popupBehavior){
this._popupBehavior.dispose();
this._popupBehavior=null;
}
this._registerPopupHandlers(false);
this._registerMouseHandlers(this._targetControl,false);
this._makeModal(false);
if(this._closeLinkHandler&&this._closeLink){
$clearHandlers(this._closeLink);
this._closeLinkHandler=null;
}
if(this._popupElement){
var _15=this.get_id();
if(_15){
var _16=$get(_15);
if(_16){
_16.appendChild(this._popupElement);
}
}
}
Telerik.Web.UI.RadToolTip.callBaseMethod(this,"dispose");
},isCreated:function(){
return this._popupElement!=null;
},get_leaveTargetAndToolTip:function(){
return this.isHideEventEnabled(Telerik.Web.UI.ToolTipHideEvent.LeaveTargetAndToolTip);
},isHideEventEnabled:function(_17){
return _17&this._hideEvent;
},hide:function(){
this._hideUnconditionally();
},_hideIfNotManualCloseOrFromCode:function(){
var _18=this.isHideEventEnabled(Telerik.Web.UI.ToolTipHideEvent.FromCode);
var _19=this.get_manualClose();
if(_19||_18){
return false;
}
this._hideUnconditionally();
return true;
},_hideUnconditionally:function(){
if(!this.isVisible()){
return;
}
this._hide();
},_hideNoAnimation:function(){
this._hide(false);
},_hide:function(_1a){
if(this._tooltipAnimation){
this._tooltipAnimation.stop();
}
this.cancelHideDelay();
this.cancelShowDelay();
this.cancelAutoCloseDelay();
var _1b=new Sys.CancelEventArgs();
this.raiseEvent("beforeHide",_1b);
if(_1b.get_cancel()){
return;
}
if(this._tooltipAnimation&&(false!=_1a)){
this._tooltipAnimation.play(true);
}else{
this._afterHide();
}
},_afterHide:function(){
try{
if(this._popupBehavior){
this._popupBehavior.hide();
this._popupBehavior.pin(false);
}
}
catch(ex){
}
this._popupVisible=false;
this._getToolTipController().notifyToolTipClosed(this);
this.raiseEvent("hide");
this._registerPopupHandlers(false);
},clone:function(_1c,_1d){
if(!_1c){
alert("clone error: No target element specified");
return;
}
var evs=this._getEventsParameter();
var _1f=this._getPropertiesParameter();
_1f["targetControlID"]=_1c.getAttribute("id");
if(!_1f["targetControlID"]){
_1f["targetControl"]=_1c;
}
var _20=document.createElement("SPAN");
if(_1d){
_20.setAttribute("id",_1d);
}
var _21=$create(Telerik.Web.UI.RadToolTip,_1f,evs,null,_20);
return _21;
},show:function(){
this._createUI();
var _22=new Sys.CancelEventArgs();
this.raiseEvent("beforeShow",_22);
if(_22.get_cancel()){
return;
}
if($telerik.isIE6){
var _23=this;
window.setTimeout(function(){
_23._registerPopupHandlers(true);
},200);
}else{
this._registerPopupHandlers(true);
}
this._popupBehavior.pin(false);
window.setTimeout(Function.createDelegate(this,function(){
this._getToolTipController().set_activeToolTip(this);
if(this._animation==Telerik.Web.UI.ToolTipAnimation.None){
this._show();
this._afterShow();
}else{
this._playAnimation();
}
}),0);
},updateLocation:function(){
this._show();
},showLoadingMessage:function(_24){
if(_24){
var div=document.createElement("DIV");
div.className=this._getFullSkinName()+" LoadingSign";
this._contentCell.appendChild(div);
}else{
this._contentCell.innerHTML="";
}
},isModal:function(){
return this._modal;
},set_contentElement:function(_26){
this._contentCell.innerHTML="";
if(_26.parentNode&&_26.parentNode.removeChild){
_26.parentNode.removeChild(_26);
}
this._contentCell.appendChild(_26);
_26.style.display="";
this._contentElement=_26;
this._setOverflow();
},get_contentElement:function(){
return this._contentElement;
},set_content:function(_27){
this._text=_27;
if(this.isCreated()){
var _28=document.createElement("DIV");
_28.innerHTML=_27;
this.set_contentElement(_28);
}
},get_content:function(){
return this._contentElement?this._contentElement.innerHTML:"";
},cancelHideDelay:function(){
if(this._hideDelayRef){
window.clearTimeout(this._hideDelayRef);
this._hideDelayRef=0;
}
},cancelAutoCloseDelay:function(){
if(this._autoCloseRef){
window.clearTimeout(this._autoCloseRef);
this._autoCloseRef=0;
}
},cancelShowDelay:function(){
if(this._showDelayRef){
window.clearTimeout(this._showDelayRef);
this._showDelayRef=null;
}
this._getToolTipController().cancelSpecificShowRequest(this);
},_getToolTipController:function(){
return Telerik.Web.UI.RadToolTipController.getInstance();
},_resetAutoCloseDelay:function(){
this.cancelAutoCloseDelay();
if(this.get_manualClose()||this.get_sticky()){
return;
}
if(this._autoCloseDelay){
this._autoCloseRef=window.setTimeout(Function.createDelegate(this,function(){
this._hideIfNotManualCloseOrFromCode();
}),this._autoCloseDelay);
}
},_resetShowDelay:function(){
this.cancelShowDelay();
var _29=Function.createDelegate(this,function(){
this._getToolTipController().showTooltip(this);
this.cancelShowDelay();
});
this._showDelayRef=window.setTimeout(_29,this._showDelay);
},_resetHideDelay:function(){
this.cancelHideDelay();
if(this._hideDelay>0){
this._hideDelayRef=window.setTimeout(Function.createDelegate(this,function(){
this._hideIfNotManualCloseOrFromCode();
}),this._hideDelay);
}else{
this._hideIfNotManualCloseOrFromCode();
}
},_show:function(){
var _2a=null;
try{
_2a=this.getToolTipBounds();
}
catch(e){
var _2b=this;
window.setTimeout(function(){
_2b._addToolTipToDocument();
},10);
return;
}
this._setPopupVisible(_2a.x,_2a.y);
this._popupVisible=true;
},_afterShow:function(){
this._popupBehavior.pin(this._isRelativeToBrowserWindow());
this._resetAutoCloseDelay();
this.raiseEvent("show");
},_isRelativeToBrowserWindow:function(){
if(!this._targetControl||this._relativeTo==Telerik.Web.UI.ToolTipRelativeDisplay.BrowserWindow){
return true;
}
return false;
},_playAnimation:function(){
var _2c=function(){
var _2d=this.controller;
var _2e=_2d.getToolTipBounds();
_2d._setPopupVisible(_2e.x,_2e.y);
var _2f=$telerik.getBounds(_2d._popupElement);
_2d._popupBehavior.hide();
this.set_endBounds(_2f);
};
if(!this._tooltipAnimation){
var pos=this._position;
var vp=this._verticalPosition;
var _32=this._isRelativeToBrowserWindow();
if(_32&&this._verticalPosition!=2){
vp=(this._verticalPosition==1?3:1);
pos=parseInt(vp+""+this._horizontalPosition);
}
var _33=_32?document.documentElement:this._targetControl;
if(this._animation==Telerik.Web.UI.ToolTipAnimation.Fade){
this._tooltipAnimation=new Telerik.Web.UI.Animations.FadeAnimation(this,null,null,this._popupElement,this._position,_33);
this._tooltipAnimation.onShowStart=function(){
this.controller._show();
};
}else{
if(this._animation==Telerik.Web.UI.ToolTipAnimation.FlyIn){
this._tooltipAnimation=new Telerik.Web.UI.Animations.FlyInAnimation(this,null,null,this._popupElement,this._position,_33);
this._tooltipAnimation.onShowStart=_2c;
}else{
if(this._animation==Telerik.Web.UI.ToolTipAnimation.Slide){
this._tooltipAnimation=new Telerik.Web.UI.Animations.SlideAnimation(this,null,null,this._popupElement,pos,_33);
this._tooltipAnimation.onShowStart=_2c;
}else{
if(this._animation==Telerik.Web.UI.ToolTipAnimation.Resize){
if(_32&&this._horizontalPosition!=2){
var hp=(this._horizontalPosition==1?3:1);
pos=parseInt(vp+""+hp);
}
this._tooltipAnimation=new Telerik.Web.UI.Animations.ResizeAnimation(this,0.2,50,this._popupElement,pos,_33);
this._tooltipAnimation.onShowStart=_2c;
}
}
}
}
}
if(this._tooltipAnimation){
if(this._isRelativeToBrowserWindow()){
this._documentOverflowX=document.documentElement.style.overflowX;
document.documentElement.style.overflowX="hidden";
}
this._tooltipAnimation.onShowEnd=function(){
this.controller._show();
if(null!=this.controller._documentOverflowX){
document.documentElement.style.overflowX=this.controller._documentOverflowX;
this.controller._documentOverflowX=null;
}
this.controller._afterShow();
};
this._tooltipAnimation.onHideEnd=function(){
this.controller._afterHide();
};
this._tooltipAnimation.play();
}
},_makeModal:function(_35){
if(this._onModalShowHandler){
this.remove_show(this._onModalShowHandler);
this._onModalShowHandler=null;
}
if(this._onModalCloseHandler){
this.remove_hide(this._onModalCloseHandler);
this._onModalCloseHandler=null;
}
if(this._modalExtender){
this._modalExtender.dispose();
this._modalExtender=null;
}
if(!_35){
return;
}
this._onModalShowHandler=function(_36){
if(!_36._modalExtender){
_36._modalExtender=new Telerik.Web.UI.ModalExtender(_36._popupElement);
}
_36._modalExtender.show();
};
this.add_show(this._onModalShowHandler);
this._onModalCloseHandler=function(_37){
if(_37._modalExtender){
_37._modalExtender.hide();
}
};
this.add_hide(this._onModalCloseHandler);
},_isMouseOverElement:function(e,_39){
var _3a=null;
try{
_3a=$telerik.getOuterBounds(_39);
}
catch(e){
return false;
}
if(e&&e.target){
var _3b=e.target.tagName;
if(_3b=="SELECT"||_3b=="OPTION"){
return true;
}
if(e.clientX<0||e.clientY<0){
return true;
}
}
var _3c=(document.compatMode&&document.compatMode!="BackCompat")?document.documentElement:document.body;
var x=e.clientX+_3c.scrollLeft;
var y=e.clientY+_3c.scrollTop;
_3a.x+=2;
_3a.y+=2;
_3a.width-=4;
_3a.height-=4;
var _3f=$telerik.containsPoint(_3a,x,y);
return _3f;
},_onMouseOver:function(e){
this._logMousePosition(e);
this._resetShowDelay();
this._getToolTipController().requestShow(this);
if(e){
}
},_onMouseMove:function(e){
this._logMousePosition(e);
this._resetAutoCloseDelay();
if(this._mouseTrailing&&this.isVisible()){
this._show();
}
},_onMouseOut:function(e){
if(!this.isVisible()){
this.cancelShowDelay();
return;
}
var _43=this._isMouseOverElement(e,this._targetControl);
if(!_43){
this.cancelShowDelay();
if(!this.get_sticky()){
this._resetHideDelay();
}
}
},_onClick:function(e){
this._onMouseOver(e);
return $telerik.cancelRawEvent(e);
},_onRightClick:function(e){
this._onMouseOver(e);
return $telerik.cancelRawEvent(e);
},_registerMouseHandlers:function(_46,_47){
if(true==_47){
var _48={};
var _49=Telerik.Web.UI.ToolTipShowEvent;
if(this._showEvent==_49.OnMouseOver){
this._onMouseOverDelegate=Function.createDelegate(this,this._onMouseOver);
this._onMouseMoveDelegate=Function.createDelegate(this,this._onMouseMove);
this._onMouseOutDelegate=Function.createDelegate(this,this._onMouseOut);
$telerik.addExternalHandler(_46,"mouseover",this._onMouseOverDelegate);
$telerik.addExternalHandler(_46,"mousemove",this._onMouseMoveDelegate);
$telerik.addExternalHandler(_46,"mouseout",this._onMouseOutDelegate);
}
if(this._showEvent==_49.OnClick){
this._onClickDelegate=Function.createDelegate(this,this._onClick);
$telerik.addExternalHandler(_46,"click",this._onClickDelegate);
}
if(this._showEvent==_49.OnRightClick){
this._onRightClickDelegate=Function.createDelegate(this,this._onRightClick);
$telerik.addExternalHandler(_46,"contextmenu",this._onRightClickDelegate);
}
if(this._showEvent==_49.OnFocus){
this._onFocusDelegate=Function.createDelegate(this,this._onMouseOver);
this._onBlurDelegate=Function.createDelegate(this,this._onMouseOut);
$telerik.addExternalHandler(_46,"focus",this._onFocusDelegate);
$telerik.addExternalHandler(_46,"blur",this._onBlurDelegate);
}
}else{
if(_46){
var _4a=[["mouseover",this._onMouseOverDelegate],["mousemove",this._onMouseMoveDelegate],["mouseout",this._onMouseOutDelegate],["click",this._onClickDelegate],["contextmenu",this._onRightClickDelegate],["focus",this._onFocusDelegate],["blur",this._onBlurDelegate]];
for(var i=0;i<_4a.length;i++){
var _4c=_4a[i];
try{
if(null!=_4c[1]){
$telerik.removeExternalHandler(_46,_4c[0],_4c[1]);
}
}
catch(e){
}
}
this._onMouseOverDelegate=null;
this._onMouseMoveDelegate=null;
this._onMouseOutDelegate=null;
this._onClickDelegate=null;
this._onRightClickDelegate=null;
this._onFocusDelegate=null;
this._onBlurDelegate=null;
}
}
},_registerPopupHandlers:function(_4d){
if(true==_4d){
if(this.get_sticky()){
this._popupStickyHandler=Function.createDelegate(this,this._onPopupStickyMouseOut);
$addHandler(this._tableElement,"mouseout",this._popupStickyHandler);
}else{
if(this.get_leaveTargetAndToolTip()){
this._popupEnterHandler=Function.createDelegate(this,this._onPopupEnterToolTip);
$addHandler(this._tableElement,"mouseover",this._popupEnterHandler);
this._popupLeaveHandler=Function.createDelegate(this,this._onPopupLeaveToolTip);
$addHandler(this._tableElement,"mouseout",this._popupLeaveHandler);
}
}
}else{
if(this._popupStickyHandler||this._popupEnterHandler||this._popupLeaveHandler){
$clearHandlers(this._tableElement);
this._popupStickyHandler=null;
this._popupEnterHandler=null;
this._popupLeaveHandler=null;
}
}
},_onPopupStickyMouseOut:function(e){
var _4f=this._isMouseOverElement(e,this._tableElement);
if(!_4f){
this._hideIfNotManualCloseOrFromCode();
}
},_onPopupEnterToolTip:function(e){
var _51=this._isMouseOverElement(e,this._tableElement);
if(_51){
this.cancelHideDelay();
this.cancelAutoCloseDelay();
}
},_onPopupLeaveToolTip:function(e){
var _53=this._isMouseOverElement(e,this._tableElement);
if(!_53){
this._resetHideDelay();
this._resetAutoCloseDelay();
}
},_getPropertiesParameter:function(){
if(!this._propertiesParameter){
var _54={};
for(var _55 in Telerik.Web.UI.RadToolTip.prototype){
var _56=this[_55];
if(typeof (_56)=="function"&&_55.indexOf("get_")==0){
var _57=_55.substring(4);
if(null==this["set_"+_57]){
continue;
}
var _58=_56.call(this);
if(null==_58){
continue;
}
_54[_57]=_58;
if(_57=="skin"){
break;
}
}
}
this._propertiesParameter=_54;
}
var _59=this._cloneObject(this._propertiesParameter);
return _59;
},_getEventsParameter:function(){
if(!this._eventsParameter){
var _5a={};
var _5b=this.get_events();
var _5c=["beforeShow","show","beforeHide","hide"];
for(var i=0;i<_5c.length;i++){
var _5e=_5c[i];
var _5f=_5b.getHandler(_5e);
if(_5f&&typeof (eval(_5f))=="function"){
_5a[_5e]=eval(_5f);
}
}
this._eventsParameter=_5a;
}
return this._eventsParameter;
},_cloneObject:function(_60){
var _61={};
for(var _62 in _60){
_61[_62]=_60[_62];
}
return _61;
},_getPosRelativeToMouse:function(_63){
var _64=_63.x;
var _65=_63.y;
var pos=this._getMousePosition();
var _67=pos.clientX;
var _68=pos.clientY;
var _69=$telerik.standardsMode;
if(!$telerik.isIE&&document.compatMode!="CSS1Compat"){
_69=false;
}else{
if($telerik.isSafari){
_69=false;
}
}
if(_69){
_64-=$telerik.getCorrectScrollLeft(document.documentElement);
_65-=document.documentElement.scrollTop;
}else{
_64-=$telerik.getCorrectScrollLeft(document.body);
_65-=document.body.scrollTop;
}
var _6a=_67-_64;
var _6b=_68-_65;
return {x:_6a,y:_6b};
},_logMousePosition:function(e){
if(!e){
return;
}
this._mouseX=e.clientX;
this._mouseY=e.clientY;
},_getMousePosition:function(){
var obj={};
obj.clientX=this._mouseX;
obj.clientY=this._mouseY;
return obj;
},_getCalloutBounds:function(){
var _6e={width:0,height:0,marginLeft:0,marginTop:0};
if(this._showCallout&&this._calloutElement){
_6e.marginLeft=parseInt($telerik.getCurrentStyle(this._calloutElement,"marginLeft"));
_6e.marginTop=parseInt($telerik.getCurrentStyle(this._calloutElement,"marginTop"));
if(isNaN(_6e.marginLeft)){
_6e.marginLeft=0;
}
if(isNaN(_6e.marginTop)){
_6e.marginTop=0;
}
var _6f=$telerik.getBounds(this._calloutElement);
if(_6f){
if(_6f.width){
_6e.width=_6f.width;
}
if(_6f.height){
_6e.height=_6f.height;
}
}
}
return _6e;
},_getBoundsRelativeToBrowser:function(_70,_71,_72){
var _73=this._horizontalPosition;
var _74=this._verticalPosition;
var x=0;
var y=0;
if(!_72){
_72=$telerik.getClientBounds();
}
var _77=$telerik.getScrollOffset(document.compatMode&&document.compatMode!="BackCompat"?document.documentElement:document.body);
if("fixed"!=this._popupElement.style.position){
x+=_77.x;
y+=_77.y;
}
switch(_73){
case 2:
x+=-parseInt(_70.width/2-_72.width/2);
x+=this._offsetX;
break;
case 3:
x+=_72.width;
x-=_70.width;
x-=this._offsetX;
break;
case 1:
default:
x+=-_70.width;
x+=(-_71.width-_71.marginLeft);
x+=this._offsetX;
break;
}
switch(_74){
case 2:
y+=-parseInt((_70.height-_72.height)/2);
break;
case 1:
y+=this._offsetY;
break;
case 3:
default:
y+=_72.height;
y-=this._offsetY;
y-=_70.height;
break;
}
return new Sys.UI.Bounds(x,y,_70.width,_70.height);
},_getBoundsRelativeToElement:function(_78,_79,_7a){
var _7b=this._horizontalPosition;
var _7c=this._verticalPosition;
var x=0;
var y=0;
if(!_7a){
_7a=$telerik.getBounds(this._targetControl);
}
switch(_7b){
case 2:
x+=-parseInt(_78.width/2-_7a.width/2);
x+=this._offsetX;
break;
case 3:
x+=_7a.width;
x-=_79.marginLeft;
x+=this._offsetX;
break;
case 1:
default:
x+=-_78.width;
x+=(-_79.width-_79.marginLeft);
x-=this._offsetX;
break;
}
switch(_7c){
case 2:
y+=-parseInt(_78.height/2-_7a.height/2);
y+=this._offsetY;
break;
case 1:
y-=_78.height;
y-=_79.height+_79.marginTop;
y-=this._offsetY;
break;
case 3:
default:
y+=_7a.height;
y-=_79.marginTop;
y+=this._offsetY;
break;
}
return new Sys.UI.Bounds(x,y,_78.width,_78.height);
},_getBoundsRelativeToMouse:function(_7f,_80,_81){
var _81=this._targetControl?$telerik.getBounds(this._targetControl):$telerik.getClientBounds();
var pos=this._getPosRelativeToMouse(_81);
if(isNaN(pos.x)){
pos.x=0;
pos.y=0;
}else{
_81.width=0;
_81.height=0;
}
var _83=this._getBoundsRelativeToElement(_7f,_80,_81);
var _84=new Sys.UI.Bounds(pos.x+_83.x,pos.y+_83.y,_7f.width,_7f.height);
return _84;
},getToolTipBounds:function(){
var _85=this._popupElement;
var _86=(_85.style.display=="none")?true:false;
if(_86){
_85.style.visibility="hidden";
}
_85.style.display="";
this._setOverflow();
if(this._firstShow!=true){
this._fixIeHeight(this._tableElement,this._height);
this._firstShow=true;
}
var _87=this._isRelativeToBrowserWindow()?document.documentElement:this._targetControl;
this._popupBehavior.set_parentElement(_87);
var _88=$telerik.getBounds(_85);
var _89=this._getCalloutBounds();
if(_86){
this._popupElement.style.display="none";
_85.style.visibility="";
}
var _8a=Telerik.Web.UI.ToolTipRelativeDisplay;
var _8b=Telerik.Web.UI.ToolTipShowEvent;
var _8c=null;
if(this._relativeTo==_8a.BrowserWindow){
_8c=this._getBoundsRelativeToBrowser(_88,_89);
}else{
if(!this._targetControl&&this._showEvent==_8b.FromCode){
_8c=this._getBoundsRelativeToBrowser(_88,_89);
}else{
if(this._targetControl&&this._showEvent==_8b.FromCode){
_8c=this._getBoundsRelativeToElement(_88,_89);
}else{
if((this._mouseTrailing||this._relativeTo==_8a.Mouse)){
_8c=this._getBoundsRelativeToMouse(_88,_89);
}else{
if(this._relativeTo==_8a.Element){
_8c=this._getBoundsRelativeToElement(_88,_89);
}
}
}
}
}
return _8c;
},_fixIeHeight:function(_8d,_8e){
if("CSS1Compat"==document.compatMode){
var _8f=(_8d.offsetHeight-parseInt(_8e));
if(_8f>0){
var _90=(parseInt(_8d.style.height)-_8f);
if(_90>0){
_8d.style.height=_90+"px";
}
}
}
},_refreshTitle:function(){
if(null==this._titleElement){
return;
}
this._titleElement.innerHTML=this._title;
this._titleElement.style.display=(this._title)?"":"none";
},_createManualCloseButton:function(_91){
if(this.get_manualClose()){
var _92=document.createElement("A");
_92.href="javascript: void(0);";
_92.className="CloseButton";
this._closeLinkHandler=Function.createDelegate(this,function(e){
this._hideUnconditionally();
return $telerik.cancelRawEvent(e);
});
$addHandler(_92,"click",this._closeLinkHandler);
this._closeLink=_92;
var _94=document.createElement("SPAN");
_94.innerHTML="Close";
_92.title="Close";
_92.appendChild(_94);
_91.appendChild(_92);
}
},_createUI:function(){
if(!this._popupElement){
var _95=this.get_id();
var _96="RadToolTipWrapper_"+_95;
var _97=document.createElement("DIV");
_97.id=_96;
var _98=this.get_element();
var _99=_98.parentNode?_98:this._getDefaultParent();
var _9a=$telerik.isRightToLeft(_99);
_97.className=this._getFullSkinName()+(this.get_showCallout()?" visiblecallout":"")+(_9a?" radtooltip_"+this._skin+"_rtl":"");
_97.setAttribute("unselectable","on");
this._popupElement=_97;
var _9b=document.createElement("DIV");
_9b.className="ToolTipCallout "+this._getCalloutPosition(this._position);
_9b.innerHTML="&nbsp;";
this._calloutElement=_9b;
var _9c=document.createElement("TABLE");
_9c.className="ToolTipWrapper";
_9c.style.width=this._width;
_9c.style.height=this._height;
this._tableElement=_9c;
var _9d=[];
if(_9a){
_9d=["ToolTipTopRight","ToolTipTopCenter","ToolTipTopLeft","ToolTipRightMiddle","ToolTipContent","ToolTipLeftMiddle","ToolTipBottomRight","ToolTipBottomCenter","ToolTipBottomLeft"];
}else{
_9d=["ToolTipTopLeft","ToolTipTopCenter","ToolTipTopRight","ToolTipLeftMiddle","ToolTipContent","ToolTipRightMiddle","ToolTipBottomLeft","ToolTipBottomCenter","ToolTipBottomRight"];
}
var _9e=0;
for(var i=1;i<=3;i++){
var _a0=_9c.insertRow(-1);
for(var j=1;j<=3;j++){
var _a2=_a0.insertCell(-1);
_a2.innerHTML="&nbsp;";
_a2.className=_9d[_9e];
_9e++;
}
}
var _a3=_9c.rows[0].cells[1];
_a3.innerHTML="";
if(_9a){
this._createManualCloseButton(_a3);
}
var _a4=document.createElement("DIV");
_a4.className="ToolTipTitlebar VisibleTitlebar";
_a4.style.display="none";
this._titleElement=_a4;
this._refreshTitle();
_a3.appendChild(_a4);
if(!_9a){
this._createManualCloseButton(_a3);
}
var _a5=_9c.rows[1].cells[1];
_a5.vAlign="top";
_a5.innerHTML="";
this._contentCell=_a5;
var _a6=null;
var _a6=null;
if(this._text){
this.set_content(this._text);
}else{
var _a7=this.get_id();
if(_a7){
_a6=$get(_a7);
}
if(_a6&&_a6.innerHTML){
var _a8=this._transferNodeChildren(_a6);
this.set_contentElement(_a8);
}
}
_97.appendChild(_9b);
_97.appendChild(_9c);
this._popupElement.style.display="none";
this._popupElement.style.position="absolute";
this._addToolTipToDocument(_a6);
}
if(!this._popupBehavior){
this._popupBehavior=$create(Telerik.Web.PopupBehavior,{"id":(new Date()-100)+"PopupBehavior","parentElement":this._targetControl},null,null,this._popupElement);
}
},_transferNodeChildren:function(_a9){
if(!_a9){
return null;
}
var _aa=_a9.ownerDocument.createElement(_a9.tagName);
var _ab=0;
while(_a9.childNodes&&_a9.childNodes.length>_ab){
var _ac=_a9.childNodes[_ab];
if(this._clientStateFieldID&&_ac.id==this._clientStateFieldID){
_ab=1;
continue;
}
_a9.removeChild(_ac);
_aa.appendChild(_ac);
}
return _aa;
},_getDefaultParent:function(){
var _ad=this._formID?document.getElementById(this._formID):null;
if(!_ad){
if(document.forms&&document.forms.length>0){
_ad=document.forms[0];
}else{
_ad=document.body;
}
}
return _ad;
},_addToolTipToDocument:function(_ae){
if(null!=_ae){
_ae.parentNode.insertBefore(this._popupElement,_ae);
return;
}
var _af=this._getDefaultParent();
_af.appendChild(this._popupElement);
},_getParentByTagName:function(_b0,_b1){
var _b2=_b0;
_b1=_b1.toUpperCase();
while(_b2.tagName.toUpperCase()!=_b1){
_b2=_b2.parentNode;
if(!_b2){
break;
}
}
return _b2;
},_getFullSkinName:function(){
return "radtooltip_"+this._skin;
},_getUniqueString:function(){
return ""+(new Date()-100);
},_getCalloutPosition:function(_b3){
with(Telerik.Web.UI.ToolTipPosition){
switch(_b3){
case TopLeft:
return "BottomRight";
case TopCenter:
return "BottomCenter";
case TopRight:
return "BottomLeft";
case MiddleLeft:
return "MiddleRight";
case Center:
return "Center";
case MiddleRight:
return "MiddleLeft";
case BottomLeft:
return "TopRight";
case BottomCenter:
return "TopCenter";
case BottomRight:
return "TopLeft";
}
}
return "";
},_getHorizontalSide:function(_b4){
return parseInt((_b4+"").charAt(1));
},_getVerticalSide:function(_b5){
return parseInt((_b5+"").charAt(0));
},_setPopupVisible:function(x,y){
this._popupBehavior.set_x(x);
this._popupBehavior.set_y(y);
this._popupBehavior.show();
if(!this.get_width()){
this._popupElement.style.width="";
}
this._popupElement.style.zIndex=this._zIndex;
},_setOverflow:function(){
var _b8=this._contentScrolling;
if(_b8==Telerik.Web.UI.ToolTipScrolling.Default){
return;
}
var el=this._contentElement;
if(!el||el.parentNode!=this._contentCell||((!el.document||!el.document.documentElement)&&$telerik.isIE)){
return;
}
var _ba="";
with(Telerik.Web.UI.ToolTipScrolling){
switch(_b8){
case Auto:
_ba="auto";
break;
case None:
_ba="hidden";
break;
case X:
_ba="";
el.style.overflowX="scroll";
el.style.overflowY="hidden";
break;
case Y:
_ba="";
el.style.overflowY="scroll";
el.style.overflowX="hidden";
break;
case Both:
_ba="scroll";
}
}
var _bb=el.parentNode;
el.style.display="none";
var _bc=$telerik.getBounds(_bb);
el.style.width=_bc.width+"px";
el.style.height=_bc.height+"px";
if(!el.style.overflowX&&!el.style.overflowY){
el.style.overflow=_ba;
}
el.style.display="";
},_getLeftOffset:function(){
var _bd=Telerik.Web.UI.ToolTipPosition;
if(_bd.Left==this._position){
return (-1*this._targetControl.offsetWidth)+this._offsetX;
}else{
if(_bd.Right==this._position){
return this._targetControl.offsetWidth+this._offsetX;
}else{
return this._offsetX;
}
}
},_getTopOffset:function(){
var _be;
var _bf=Telerik.Web.UI.ToolTipPosition;
if(_bf.Top==this._position){
_be=(-1*this._targetControl.offsetHeight)+this._offsetY;
}else{
if(_bf.Bottom==this._position){
_be=this._targetControl.offsetHeight+this._offsetY;
}else{
_be=this._offsetY;
}
}
return _be;
},isVisible:function(){
var _c0=this._popupElement;
return (_c0&&_c0.style.display!="none");
},get_targetControlID:function(){
return this._targetControlID;
},set_targetControlID:function(_c1){
if(this._targetControlID!=_c1){
this._targetControlID=_c1;
var _c2=(this._targetControlID?$get(this._targetControlID):null);
this.set_targetControl(_c2);
}
},get_serverTargetControlID:function(){
return this._serverTargetControlID;
},set_serverTargetControlID:function(_c3){
this._serverTargetControlID=_c3;
},get_serverValue:function(){
return this._serverValue;
},set_serverValue:function(_c4){
this._serverValue=_c4;
},get_value:function(){
return this.get_serverValue();
},set_value:function(_c5){
this.set_serverValue(_c5);
},get_formID:function(){
return this._formID;
},set_formID:function(_c6){
if(this._formID!=_c6){
this._formID=_c6;
}
},get_position:function(){
return this._position;
},set_position:function(_c7){
if(this._position!=_c7){
this._position=_c7;
if(this._calloutElement){
this._calloutElement.className="ToolTipCallout "+this._getCalloutPosition(this._position);
}
}
this._horizontalPosition=this._getHorizontalSide(this._position);
this._verticalPosition=this._getVerticalSide(this._position);
},get_offsetX:function(){
return this._offsetX;
},set_offsetX:function(_c8){
if(this._offsetX!=_c8){
this._offsetX=_c8;
}
},get_offsetY:function(){
return this._offsetY;
},set_offsetY:function(_c9){
if(this._offsetY!=_c9){
this._offsetY=_c9;
}
},get_title:function(){
return this._title;
},set_title:function(_ca){
if(this._title!=_ca){
this._title=_ca;
}
this._refreshTitle();
},get_text:function(){
return this._text;
},set_text:function(_cb){
if(this._text!=_cb){
this._text=_cb;
}
if(this.isCreated()){
this.set_content(this._text);
}
},get_width:function(){
return this._width;
},set_width:function(_cc){
if(this._width!=_cc){
this._width=_cc;
}
},get_height:function(){
return this._height;
},set_height:function(_cd){
if(this._height!=_cd){
this._height=_cd;
}
},get_relativeTo:function(){
return this._relativeTo;
},set_relativeTo:function(_ce){
if(this._relativeTo!=_ce){
this._relativeTo=_ce;
}
},get_contentScrolling:function(){
return this._contentScrolling;
},set_contentScrolling:function(_cf){
if(this._contentScrolling!=_cf){
this._contentScrolling=_cf;
}
},get_sticky:function(){
return this.isHideEventEnabled(Telerik.Web.UI.ToolTipHideEvent.LeaveToolTip);
},set_sticky:function(_d0){
if(this._sticky!=_d0){
this._sticky=_d0;
}
if(this._sticky){
this.set_hideEvent(Telerik.Web.UI.ToolTipHideEvent.LeaveToolTip);
}
},get_manualClose:function(){
return this.isHideEventEnabled(Telerik.Web.UI.ToolTipHideEvent.ManualClose);
},set_manualClose:function(_d1){
if(this._manualClose!=_d1){
this._manualClose=_d1;
}
if(this._manualClose){
this.set_hideEvent(Telerik.Web.UI.ToolTipHideEvent.ManualClose);
}
},get_showCallout:function(){
return this._showCallout;
},set_showCallout:function(_d2){
if(this._showCallout!=_d2){
this._showCallout=_d2;
}
},get_showDelay:function(){
return this._showDelay;
},set_showDelay:function(_d3){
if(this._showDelay!=_d3){
this._showDelay=_d3;
}
},get_autoCloseDelay:function(){
return this._autoCloseDelay;
},set_autoCloseDelay:function(_d4){
if(this._autoCloseDelay!=_d4){
this._autoCloseDelay=_d4;
}
},get_hideDelay:function(){
return this._hideDelay;
},set_hideDelay:function(_d5){
if(this._hideDelay!=_d5){
this._hideDelay=_d5;
}
},get_mouseTrailing:function(){
return this._mouseTrailing;
},set_mouseTrailing:function(_d6){
if(this._mouseTrailing!=_d6){
this._mouseTrailing=_d6;
if(true==_d6){
this.set_relativeTo(Telerik.Web.UI.ToolTipRelativeDisplay.Mouse);
}
}
},get_visibleOnPageLoad:function(){
return this._visibleOnPageLoad;
},set_visibleOnPageLoad:function(_d7){
if(this._visibleOnPageLoad!=_d7){
this._visibleOnPageLoad=_d7;
}
},get_animation:function(){
return this._animation;
},set_animation:function(_d8){
if(this._animation!=_d8){
this._animation=_d8;
}
},get_showEvent:function(){
return this._showEvent;
},set_showEvent:function(_d9){
if(this._showEvent!=_d9){
this._showEvent=_d9;
}
},get_hideEvent:function(){
return this._hideEvent;
},set_hideEvent:function(_da){
if(this._hideEvent!=_da){
this._hideEvent=_da;
}
},get_modal:function(){
return this._modal;
},set_modal:function(_db){
if(this._modal!=_db){
this._modal=_db;
}
this._makeModal(this._modal);
},get_skin:function(){
return this._skin;
},set_skin:function(_dc){
if(_dc&&this._skin!=_dc){
this._skin=_dc;
}
},get_targetControl:function(){
return this._targetControl;
},set_targetControl:function(_dd){
if(this._targetControl!=_dd){
if(this._targetControl&&(this._targetControl!=_dd)){
this._registerMouseHandlers(this._targetControl,false);
}
this._targetControl=_dd;
var _de=this._targetControl;
if(_de){
if($telerik.isIE&&_de){
_de.removeAttribute("alt");
}
this._registerMouseHandlers(_de,true);
if(this._popupBehavior){
this._popupBehavior.set_parentElement(_de);
}
}
}
},get_popupElement:function(){
return this._popupElement;
},add_beforeShow:function(_df){
this.get_events().addHandler("beforeShow",_df);
},remove_beforeShow:function(_e0){
this.get_events().removeHandler("beforeShow",_e0);
},add_show:function(_e1){
this.get_events().addHandler("show",_e1);
},remove_show:function(_e2){
this.get_events().removeHandler("show",_e2);
},add_beforeHide:function(_e3){
this.get_events().addHandler("beforeHide",_e3);
},remove_beforeHide:function(_e4){
this.get_events().removeHandler("beforeHide",_e4);
},add_hide:function(_e5){
this.get_events().addHandler("hide",_e5);
},remove_hide:function(_e6){
this.get_events().removeHandler("hide",_e6);
},saveClientState:function(){
var _e7=["text","position"];
var _e8={};
for(var i=0;i<_e7.length;i++){
_e8[_e7[i]]=this["get_"+_e7[i]]();
}
return Sys.Serialization.JavaScriptSerializer.serialize(_e8);
}};
Telerik.Web.UI.RadToolTip.registerClass("Telerik.Web.UI.RadToolTip",Telerik.Web.UI.RadWebControl);
Telerik.Web.UI.ToolTipPosition=function(){
throw Error.invalidOperation();
};
Telerik.Web.UI.ToolTipPosition.prototype={TopLeft:11,TopCenter:12,TopRight:13,MiddleLeft:21,Center:22,MiddleRight:23,BottomLeft:31,BottomCenter:32,BottomRight:33};
Telerik.Web.UI.ToolTipPosition.registerEnum("Telerik.Web.UI.ToolTipPosition",false);
Telerik.Web.UI.ToolTipRelativeDisplay=function(){
throw Error.invalidOperation();
};
Telerik.Web.UI.ToolTipRelativeDisplay.prototype={Mouse:0,Element:1,BrowserWindow:2};
Telerik.Web.UI.ToolTipRelativeDisplay.registerEnum("Telerik.Web.UI.ToolTipRelativeDisplay",false);
Telerik.Web.UI.ToolTipScrolling=function(){
throw Error.invalidOperation();
};
Telerik.Web.UI.ToolTipScrolling.prototype={Auto:0,None:1,X:2,Y:3,Both:4,Default:5};
Telerik.Web.UI.ToolTipScrolling.registerEnum("Telerik.Web.UI.ToolTipScrolling",false);
Telerik.Web.UI.ToolTipAnimation=function(){
throw Error.invalidOperation();
};
Telerik.Web.UI.ToolTipAnimation.prototype={None:0,Resize:1,Fade:2,Slide:4,FlyIn:8};
Telerik.Web.UI.ToolTipAnimation.registerEnum("Telerik.Web.UI.ToolTipAnimation",false);
Telerik.Web.UI.ToolTipShowEvent=function(){
throw Error.invalidOperation();
};
Telerik.Web.UI.ToolTipShowEvent.prototype={OnMouseOver:1,OnClick:2,OnRightClick:4,OnFocus:8,FromCode:16};
Telerik.Web.UI.ToolTipShowEvent.registerEnum("Telerik.Web.UI.ToolTipShowEvent",false);
Telerik.Web.UI.ToolTipHideEvent=function(){
throw Error.invalidOperation();
};
Telerik.Web.UI.ToolTipHideEvent.prototype={Default:1,LeaveToolTip:2,ManualClose:4,LeaveTargetAndToolTip:8,FromCode:16};
Telerik.Web.UI.ToolTipHideEvent.registerEnum("Telerik.Web.UI.ToolTipHideEvent",false);

